#
# This is the SPEC file for creating binary and source RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#


%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Name:		qubes-gui-dom0	
Version:	4.0.14
Release:	1%{dist}
Summary:	The Qubes GUI virtualization (Dom0 side) 

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

Requires:	qubes-core-dom0 >= 1.3.14
Requires:	xorg-x11-server-Xorg pulseaudio-libs
Requires:	service(graphical-login)
Requires:	pulseaudio
Requires:	libconfig
Requires:	qubes-libvchan-xen
Requires:   python3-xcffib
Requires:   qubes-utils >= 3.1.0
Requires:   python3-pydbus
Requires:   python3-setuptools

BuildRequires:  python3-devel
BuildRequires:	pulseaudio-libs-devel
BuildRequires:	libXt-devel
BuildRequires:	libXext-devel
BuildRequires:	libXrandr-devel
BuildRequires:	libconfig-devel
BuildRequires:	libpng-devel
BuildRequires:	libnotify-devel
BuildRequires:	xen-devel
BuildRequires:	dbus-glib-devel
BuildRequires:	help2man
BuildRequires:	gcc
BuildRequires:	qubes-core-libs-devel >= 1.6.1
BuildRequires:	qubes-core-libs
BuildRequires:	qubes-gui-common-devel >= 3.2.0
BuildRequires:	qubes-libvchan-xen-devel

Source0: %{name}-%{version}.tar.gz

%description
The Qubes GUI virtualization infrastructure that needs to be installed in Dom0.

%prep
%setup -q

%build
%{?set_build_flags}
make clean
make all BACKEND_VMM=xen

%py3_build

%pre

%install
rm -rf $RPM_BUILD_ROOT
%make_install
%py3_install

%triggerin -- xorg-x11-server-Xorg
ln -sf /usr/bin/X-wrapper-qubes /usr/bin/X

%postun
if [ "$1" = 0 ] ; then
	# no more packages left
    ln -sf /usr/bin/Xorg /usr/bin/X
fi

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)
%attr(4750,root,qubes) /usr/bin/qubes-guid
%{_mandir}/man1/qubes-guid.1.gz
/usr/bin/pacat-simple-vchan
/usr/bin/X-wrapper-qubes
%{_libdir}/shmoverride.so
%config(noreplace) %{_sysconfdir}/qubes/guid.conf
%config(noreplace) %{_sysconfdir}/qubes-rpc/policy/qubes.ClipboardPaste
/etc/xdg/autostart/qubes-screen-layout-watches.desktop
/etc/X11/xinit/xinitrc.d/qubes-localgroup.sh
/usr/share/dbus-1/interfaces/org.qubesos.Audio.xml
%config(noreplace) /etc/dbus-1/system.d/org.qubesos.Audio.conf
/usr/libexec/qubes/watch-screen-layout-changes
/usr/lib/qubes/icon-receiver
%config(noreplace) %{_sysconfdir}/qubes-rpc/policy/qubes.WindowIconUpdater
%config %{_sysconfdir}/qubes-rpc/qubes.WindowIconUpdater
%{python3_sitelib}/qubesguidaemon-*.egg-info
%{python3_sitelib}/qubesguidaemon

%changelog
* Tue Aug 31 2021 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-gui-daemon.git

* Tue Aug 31 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a18383c
- version 4.0.14

* Tue Aug 31 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - fd3fa3d
- zero-out msg_configure before filling it

* Tue Aug 31 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 76912bc
- Avoid rogue screen locking

* Tue Jun 01 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - aef2c62
- version 4.0.13

* Tue Jun 01 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 88adb0f
- Fix clipboard stop working after ~50 days of uptime

* Tue Jun 01 2021 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 8ce26bd
- Enforce locale for help2man

* Tue Jun 01 2021 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - e86d19b
- Add .gitlab-ci.yml

* Tue Jun 01 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 81a47ce
- xside: don't hang indefinitely if VM is killed early

* Tue Jun 01 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0ccad0f
- Fix handling X11 exit

* Thu Jul 30 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 023d656
- version 4.0.12

* Thu Jul 30 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 51cb97a
- Handle destroyed windows in restack_windows

* Thu Jul 30 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 185ad32
- Make screensaver detection configurable

* Thu Jul 30 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 0cec9ea
- Prevent VM notifications from appearing on top of xscreensaver

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - eabfcc6
- version 4.0.11

* Sun May 17 2020 Ivan Kardykov <kardykov@tabit.pro> - f94cc24
- set override redirect attribute on window creating

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d5ced8c
- rpm: use rpm-build provided CFLAGS for pacat-simple-vchan

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e656b50
- pulse: periodically check if vchan connection is alive

* Sun May 17 2020 M. Vefa Bicakci <m.v.b@runbox.com> - f40a8fc
- xside: Introduce override_redirect protection

* Sun May 17 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - b885b8d
- shmoverride: handle Xorg crash leaving shm.id file

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 512ca76
- Fix tray icon coloring code - do not crop/dislocate icon fragments

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6db5575
- Make qubes.WindowIconUpdater a proper script

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a14b921
- Make files in qubes-rpc executable

* Sun May 17 2020 xaki23 <tvguho-knxv23-tct.e23f2f1b@hashmail.org> - e211741
- allow domid 0 as target

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 35dd26f
- Fix file permissions - drop executable bit where not needed

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 415bb29
- makefile: remove obsolete rpm building rules

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3012c3e
- rpm: fix building with mock

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6c1d571
- rpm: move installation commands to Makefile

* Sun May 17 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 84f32f3
- Fix a bunch of compiler warnings

* Fri Jan 31 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ea52731
- version 4.0.10

* Wed Jan 29 2020 Snowy Marmot <marmot1791@protonmail.com> - 7e06c96
- Review and fix spelling

* Wed Jan 29 2020 Snowy Marmot <marmot1791@protonmail.com> - 7da6b1b
- Add exmaples/comments to guid.conf

* Wed Jan 29 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d2bec90
- Handle XShmAttach errors reported asynchronously

* Sun Oct 20 2019 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 0770f27
- travis: switch to bionic

* Sat Sep 15 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1f55c60
- version 4.0.9

* Sat Sep 15 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a90544a
- xside: avoid making X11 calls in signal handler

* Thu Sep 13 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - af14f3e
- Clarify error message on mic attach if audio not enabled in the VM

* Fri Jul 27 2018 Jean-Philippe Ouellet <jpo@vt.edu> - 148fb42
- Correct note about "temporary" shm lifecycle

* Tue May 08 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6f5587b
- version 4.0.8

* Tue May 08 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 325a784
- gui-daemon: fix potential int overflow

* Sat Apr 21 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2057273
- gui-daemon: fix forcing colorful frame when vm_window->image == NULL

* Tue Apr 03 2018 Frédéric Pierret <frederic.epitre@orange.fr> - 8eb0ae9
- spec.in: add changelog placeholder

* Sun Apr 01 2018 Frédéric Pierret <frederic.epitre@orange.fr> - 8d09634
- Create .spec.in and Source0

* Sun Mar 04 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5340e17
- version 4.0.7

* Sun Mar 04 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 72c8cda
- icon-receiver: make it more defensive against X11 race conditions

* Fri Dec 29 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7b4c255
- icon-receiver: cache icons received for not (yet) existing windows

* Sat Dec 23 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 35ec463
- version 4.0.6

* Wed Dec 06 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 94fd49d
- Move path to qvm-kill into header

* Wed Dec 06 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 4b0fd06
- Group file paths

* Wed Dec 06 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 0304cd2
- Remove dependency on xl toolstack

* Wed Dec 06 2017 Jean-Philippe Ouellet <jpo@vt.edu> - bf46809
- Actually dispatch resolution change notifications

